Unit Gfx;

{****************************************************************************}
Interface
{****************************************************************************}

Type
  BMPhead = Record
              sign      : Array [1..2] Of Char;
              file_size : LongInt;
              reserved  : LongInt;
              bmp_ofs   : LongInt;
              head_size : LongInt;
              width     : LongInt;
              height    : LongInt;
              plane_nb  : Word;
              bit_nb    : Word;
              compress  : LongInt;
              bmp_size  : LongInt;
              ppmX      : LongInt;
              ppmY      : LongInt;
              used_col  : LongInt;
              imp_col   : LongInt;
              color0    : LongInt;
              color1    : LongInt;
            End;
Const
  BMP : BMPhead =
       (sign      :'BM';
        file_size :0;
        reserved  :0;
        bmp_ofs   :$3E;
        head_size :$28;
        width     :0;
        height    :0;
        plane_nb  :1;
        bit_nb    :1;
        compress  :0;
        bmp_size  :0;
        ppmX      :0;
        ppmY      :0;
        used_col  :2;
        imp_col   :0;
        color0    :$000000;
        color1    :$FFFFFF);

Procedure SetRGB (index,r,g,b : Byte);
Procedure Pixel (x,y : Word; col : Byte);
Procedure GButton (x,y : Byte; s : String);
Procedure Disp_bitmap (x,y : Byte; p : Pointer);
Procedure Save_bitmap (x,y : Word; p : Pointer; name : String);

{****************************************************************************}
Implementation
{****************************************************************************}

Procedure _Write (x,y : Byte; s : String); Assembler;
Asm
    push es
    push bp

    mov  ax,ss
    mov  es,ax
    mov  ax,1300h
    mov  bx,000Fh
    xor  ch,ch
    mov  cl,byte ptr es:[bp+16h]
    mov  dl,byte ptr es:[bp+0Ah]
    mov  dh,byte ptr es:[bp+08h]
    add  bp,17h
    int  10h

    pop  bp
    pop  es
End;

Procedure SetRGB (index,r,g,b : Byte); Assembler;
Asm
  mov al,index
  mov dx,3c8h
  out dx,al
  inc dx
  mov al,r
  out dx,al
  mov al,g
  out dx,al
  mov al,b
  out dx,al
End;

Procedure Pixel (x,y : Word; col : Byte); Assembler;
Asm
  push es
  mov  ax,0a000h
  mov  es,ax
  mov  ax,320
  mul  y
  mov  bx,x
  add  bx,ax
  mov  cl,col
  mov  es:[bx],cl
  pop  es
End;

Procedure GButton (x,y : Byte; s : String);
Var
  i,ll,xx,yy : Word;
Begin
  _Write (x,y,s);
  xx :=x Shl 3;
  yy :=y Shl 3;
  ll :=Length (s) Shl 3;
  For i :=xx To xx+ll-1 Do
  Begin
    Pixel (i,yy-3,15);
    Pixel (i,yy+9,15);
  End;
  For i :=yy-2 To yy+8 Do
  Begin
    Pixel (xx-1,i,15);
    Pixel (xx+ll,i,15);
  End;
End;

Procedure Disp_bitmap (x,y : Byte; p : Pointer);
Begin
  Asm
    push ds
    push es
    mov  ax,0a000h
    mov  es,ax
    {center bitmap}
    mov  ax,320
    mov  bx,200
    xor  ch,ch
    mov  cl,y
    sub  bx,cx
    shr  bx,1
    mul  bx
    xor  ch,ch
    mov  cl,x
    mov  bx,320
    sub  bx,cx
    shr  bx,1
    add  bx,ax
    {go}
    mov  di,ss:[bp+6]
    mov  ax,ss:[bp+8]
    mov  ds,ax
    mov  dh,y
    @loopy:
          mov  dl,x
          shr  dl,3
          @loopx:
               mov  cl,ds:[di]
               mov  ch,8
               @bits:
                    mov  al,cl
                    shr  al,7
                    and  al,1
                    inc  al
                    mov  es:[bx],al
                    shl  cl,1
                    inc  bx
                    dec  ch
                    jnz  @bits
               inc  di
               dec  dl
               jnz  @loopx
          add  bx,80
          dec  dh
          jnz  @loopy
    pop  es
    pop  ds
  End;
End;

Procedure Save_bitmap (x,y : Word; p : Pointer; name : String);
Type
  t_array = Array [0..0] Of Byte;
  pt_array = ^t_array;
Var
  f : File;
  i,o,xx,w : Word;
Begin
  {x multiple of 8}
  xx :=x Shr 3;
  With BMP Do
  Begin
    bmp_size :=xx*y;
    file_size :=bmp_size+$3E;
    width :=x;
    height :=y;
  End;
  Assign (f,name);
  Rewrite (f,1);
  BlockWrite (f,BMP,SizeOf (BMPhead));
  w :=0;
  o :=BMP.bmp_size-xx;
  For i :=1 To y Do
  Begin
    BlockWrite (f,pt_array (p)^[o],xx);
    BlockWrite (f,w,2);
    Dec (o,xx);
  End;
  Close (f);
End;

End.
