Unit Timer;

Interface

Const
  count  : Word = 0;
  count1 : Word = 0;
  count2 : Word = 0;

Procedure Install_timer;
Procedure Uninstall_timer;
Procedure Delay (t : Word);

Implementation

Const
  freq = 100; {unit = 1/100th of second}
  counter = 1193181 Div freq;
Var
  ticks : Word;
  old_int : Procedure;
  IntVec : Array [0..255] Of Pointer Absolute 0:0;

Procedure Timer_hook; Interrupt; Assembler;
Asm
  {If count2>0 Then
    Dec (count2);}
  cmp  count2,0
  je   @zero2
  dec  count2
  @zero2:
  {If count1>0 Then
    Dec (count1);}
  cmp  count1,0
  je   @zero1
  dec  count1
  @zero1:
  {If count>0 Then
    Dec (count);}
  cmp  count,0
  je   @zero
  dec  count
  @zero:
  {Inc (ticks,counter);}
  add  ticks,counter

  jnc  @eoi
       pushf
       call old_int
  jmp  @end

  @eoi:
  push ax
  mov  al,20h
  out  20h,al
  pop  ax
  @end:
End;

Procedure Install_timer;
Begin
  ticks :=0;
  @old_int :=IntVec[8];
  Asm
    cli
  End;
  IntVec[8] :=@Timer_hook;
  Asm
    {Port[$43] :=32+16+4+2;}
    mov  dx,43h
    mov  al,36h
    out  dx,al
    jmp  @next1
    @next1:
    {Port[$40] :=counter And 255;}
    mov  dx,40h
    mov  ax,counter
    out  dx,al
    jmp  @next2
    @next2:
    {Port[$40] :=counter Shr 8;}
    mov  al,ah
    out  dx,al
    jmp  @next3
    @next3:
    sti
  End;
End;

Procedure Uninstall_timer;
Begin
  Asm
    cli
    {Port[$43] :=32+16+4+2;}
    mov  dx,43h
    mov  al,36h
    out  dx,al
    jmp  @next1
    @next1:
    {Port[$40] :=0;}
    mov  dx,40h
    xor  al,al
    out  dx,al
    jmp  @next2
    @next2:
    {Port[$40] :=0;}
    out  dx,al
    jmp  @next3
    @next3:
  End;
  IntVec[8] :=@old_int;
  Asm
    sti
  End;
End;

Procedure Delay (t : Word);
Begin
  count :=t;
  While (count<>0) Do;
End;

End.
